/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.40 from the
 * contents of Util.xs. Do not edit this file, edit Util.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Util.xs"

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "lkhutmp.h"

#define Hangul_SBase  0xAC00
#define Hangul_SFinal 0xD7A3
#define Hangul_SCount  11172
#define Hangul_NCount    588
#define Hangul_LBase  0x1100
#define Hangul_LFinal 0x1112
#define Hangul_LCount     19
#define Hangul_VBase  0x1161
#define Hangul_VFinal 0x1175
#define Hangul_VCount     21
#define Hangul_TBase  0x11A7
#define Hangul_TFinal 0x11C2
#define Hangul_TCount     28
#define Hangul_JBase  0x1100
#define Hangul_JFinal 0x11FF
#define Hangul_JCount    256

#define Hangul_IsS(u)  ((Hangul_SBase <= (u)) && ((u) <= Hangul_SFinal))
#define Hangul_IsN(u)  (! (((u) - Hangul_SBase) % Hangul_TCount))
#define Hangul_IsLV(u) (Hangul_IsS(u) && Hangul_IsN(u))
#define Hangul_IsL(u)  ((Hangul_LBase <= (u)) && ((u) <= Hangul_LFinal))
#define Hangul_IsV(u)  ((Hangul_VBase <= (u)) && ((u) <= Hangul_VFinal))
#define Hangul_IsT(u)  ((Hangul_TBase  < (u)) && ((u) <= Hangul_TFinal))
#define Hangul_IsJ(u)  ((Hangul_JBase <= (u)) && ((u) <= Hangul_JFinal))

#define Hangul_BName "HANGUL SYLLABLE "
#define Hangul_BNameLen 16
#define Hangul_LLenMax   2
#define Hangul_VLenMax   3
#define Hangul_TLenMax   2
#define Hangul_NameMax  23

#define IsHangulNameV(c) ( \
  (c) == 'A' || (c) == 'E' || (c) == 'I' || (c) == 'O' || \
  (c) == 'U' || (c) == 'W' || (c) == 'Y' )

#define IsHangulNameC(c) ( \
  (c) == 'G' || (c) == 'N' || (c) == 'D' || (c) == 'R' || (c) == 'L' || \
  (c) == 'M' || (c) == 'B' || (c) == 'S' || (c) == 'J' || (c) == 'C' || \
  (c) == 'K' || (c) == 'T' || (c) == 'P' || (c) == 'H' )

static char* hangul_JamoL[] = { /* Initial (HANGUL CHOSEONG) */
    "G", "GG", "N", "D", "DD", "R", "M", "B", "BB",
    "S", "SS", "", "J", "JJ", "C", "K", "T", "P", "H"
  };

static char* hangul_JamoV[] = { /* Medial (HANGUL JUNGSEONG) */
    "A", "AE", "YA", "YAE", "EO", "E", "YEO", "YE", "O",
    "WA", "WAE", "OE", "YO", "U", "WEO", "WE", "WI", "YU", "EU", "YI", "I"
  };

static char* hangul_JamoT[] = { /* Final (HANGUL JONGSEONG) */
    "", "G", "GG", "GS", "N", "NJ", "NH", "D", "L", "LG", "LM",
    "LB", "LS", "LT", "LP", "LH", "M", "B", "BS",
    "S", "SS", "NG", "J", "C", "K", "T", "P", "H"
  };

/* Hangul Syllable Type */
#define Jamo_LIni	(0x1100)
#define Jamo_LFin	(0x1159)
#define Jamo_LFill	(0x115F)
#define Jamo_VIni	(0x1160)
#define Jamo_VFin	(0x11A2)
#define Jamo_TIni	(0x11A8)
#define Jamo_TFin	(0x11F9)

/* Perl 5.6.1 ? */
#ifndef uvuni_to_utf8
#define uvuni_to_utf8   uv_to_utf8
#endif /* uvuni_to_utf8 */

/* Perl 5.6.1 ? */
#ifndef utf8n_to_uvuni
#define utf8n_to_uvuni  utf8_to_uv
#endif /* utf8n_to_uvuni */

/* if utf8n_to_uvuni() sets retlen to 0 when flags = 0 */
#define ErrRetlenIsZero "panic (Lingua::KO::Hangul::Util)" \
	": zero-length character"

static UV compositeHangul (UV uv, UV uv2)
{
    if (Hangul_IsL(uv) && Hangul_IsV(uv2)) {
	uv  -= Hangul_LBase; /* lindex */
	uv2 -= Hangul_VBase; /* vindex */
	return(Hangul_SBase + (uv * Hangul_VCount + uv2) * Hangul_TCount);
    }
    if (Hangul_IsLV(uv) && Hangul_IsT(uv2)) {
	uv2 -= Hangul_TBase; /* tindex */
	return(uv + uv2);
    }
    return 0;
}

static void sv_cat_decompSyl (SV* sv, UV uv)
{
    UV sindex, lindex, vindex, tindex;
    U8 *t, tmp[3 * UTF8_MAXLEN + 1];

    if (! Hangul_IsS(uv))
	return;

    sindex =  uv - Hangul_SBase;
    lindex =  sindex / Hangul_NCount;
    vindex = (sindex % Hangul_NCount) / Hangul_TCount;
    tindex =  sindex % Hangul_TCount;

    t = tmp;
    t = uvuni_to_utf8(t, (lindex + Hangul_LBase));
    t = uvuni_to_utf8(t, (vindex + Hangul_VBase));
    if (tindex)
	t = uvuni_to_utf8(t, (tindex + Hangul_TBase));
    *t = '\0';
    sv_catpvn(sv, (char *)tmp, strlen((char *)tmp));
}

static void sv_cat_decompJamo (SV* sv, UV uv)
{
    U8 idx, *t, tmp[3 * UTF8_MAXLEN + 1];
    STDCHAR *s, *p;

    if (! Hangul_IsJ(uv))
	return;

    idx = (U8)(uv & 0xFF);
    t = tmp;
    for (p = s = LKHU_Decomp[idx];
	 (p == s) || (p - s < LKHU_DecompCnt && *p != LKHU_DecompEnd);
	 p++)
    /* (p == s) for U+11FF (must output at least one char */
    {
	t = uvuni_to_utf8(t, 0x1100 + (UV)(*p & 0xFF));
    }
    *t = '\0';
    sv_catpvn(sv, (char *)tmp, strlen((char *)tmp));
}

static char * sv_2pvunicode(SV *sv, STRLEN *lp)
{
    char *s;
    STRLEN len;
    s = (char*)SvPV(sv,len);
    if (!SvUTF8(sv)) {
	SV* tmpsv = sv_mortalcopy(sv);
	if (!SvPOK(tmpsv))
	    (void)sv_pvn_force(tmpsv,&len);
	sv_utf8_upgrade(tmpsv);
	s = (char*)SvPV(tmpsv,len);
    }
    *lp = len;
    return s;
}

#line 171 "Util.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 315 "Util.c"

XS_EUPXS(XS_Lingua__KO__Hangul__Util_composeJamo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__KO__Hangul__Util_composeJamo)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "src");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	src = ST(0)
;
#line 169 "Util.xs"
    SV *dst;
    U8 *s, *p, *e, *d;
    UV uv;
    STRLEN srclen, dstlen, retlen;
    LKHU_CompStruct *i, *complist;
    bool fcomposed;
#line 335 "Util.c"
#line 176 "Util.xs"
    s = (U8*)sv_2pvunicode(src,&srclen);
    e = s + srclen;

    dstlen = srclen + 1; /* equal or shorter */
    dst = newSV(dstlen);
    SvPOK_only(dst);
    SvUTF8_on(dst);
    d = (U8*)SvPVX(dst);

    for (p = s; p < e;) {
	uv = utf8n_to_uvuni(p, e - p, &retlen, 0);
	if (!retlen)
	    croak(ErrRetlenIsZero);
	p += retlen;

	fcomposed = FALSE;
	if (Hangul_IsJ(uv) && (complist = LKHU_Comp[uv & 0xFF])) {
	    for (i = complist; i->len; i++) {
		if (i->len <= (e - p) && memEQ(p, i->trail, i->len)) {
		    d = uvuni_to_utf8(d, i->composite);
		    p += i->len;
		    fcomposed = TRUE;
		    break;
		}
	    }
	}
	if (!fcomposed)
	    d = uvuni_to_utf8(d, uv);
    }
    *d = '\0';
    SvCUR_set(dst, d - (U8*)SvPVX(dst));
    XPUSHs(dst);
#line 369 "Util.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lingua__KO__Hangul__Util_composeSyllable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__KO__Hangul__Util_composeSyllable)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "src");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	src = ST(0)
;
#line 216 "Util.xs"
    SV *dst;
    U8 *s, *p, *e, *d;
    UV lastuv, nextuv, lindex, vindex, tindex;
    STRLEN srclen, dstlen, curlen, retlen;
#line 392 "Util.c"
#line 221 "Util.xs"
    s = (U8*)sv_2pvunicode(src,&srclen);
    e = s + srclen;

    dstlen = srclen + 1; /* equal or shorter */
    dst = newSV(dstlen);
    SvPOK_only(dst);
    SvUTF8_on(dst);
    d = (U8*)SvPVX(dst);

    for (p = s; p < e; ) {
	lastuv = utf8n_to_uvuni(p, e - p, &retlen, 0);
	if (!retlen)
	    croak(ErrRetlenIsZero);

	p += retlen;
	curlen = e - p;
	if (curlen) {
	    nextuv = utf8n_to_uvuni(p, curlen, &retlen, 0);
	    if (!retlen)
		croak(ErrRetlenIsZero);
	}

     /* 1. composed if lastuv is L and nextuv is V. */
	if (curlen && Hangul_IsL(lastuv) && Hangul_IsV(nextuv)) {
	    lindex = lastuv - Hangul_LBase;
	    vindex = nextuv - Hangul_VBase;
	    lastuv = Hangul_SBase +
		(lindex * Hangul_VCount + vindex) * Hangul_TCount;
	    p += retlen;
	    curlen = e - p;
	    if (curlen) {
		nextuv = utf8n_to_uvuni(p, curlen, &retlen, 0);
		if (!retlen)
		    croak(ErrRetlenIsZero);
	    }
	}

     /* 2. composed if lastuv is LV and nextuv is T. */
	if (curlen && Hangul_IsLV(lastuv) && Hangul_IsT(nextuv)) {
	    tindex = nextuv - Hangul_TBase;
	    lastuv += tindex;
	    p += retlen;
	}

	d = uvuni_to_utf8(d, lastuv);
    }
    *d = '\0';
    SvCUR_set(dst, d - (U8*)SvPVX(dst));
    XPUSHs(dst);
#line 443 "Util.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lingua__KO__Hangul__Util_decomposeSyllable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__KO__Hangul__Util_decomposeSyllable)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "src");
    {
	SV *	src = ST(0)
;
#line 279 "Util.xs"
    UV uv;
    SV *dst;
    STRLEN srclen, retlen;
    U8 *s, *e, *p;
#line 465 "Util.c"
	SV *	RETVAL;
#line 284 "Util.xs"
    s = (U8*)sv_2pvunicode(src,&srclen);
    e = s + srclen;

    dst = newSV(1);
    SvPOK_only(dst);
    SvUTF8_on(dst);

    for (p = s; p < e; p += retlen) {
	uv = utf8n_to_uvuni(p, e - p, &retlen, 0);
	if (!retlen)
	    croak(ErrRetlenIsZero);

	if (ix == 0 && Hangul_IsS(uv))
	    sv_cat_decompSyl(dst, uv);
	else if (ix == 1 && Hangul_IsJ(uv))
	    sv_cat_decompJamo(dst, uv);
	else
	    sv_catpvn(dst, (char *)p, retlen);
    }
    RETVAL = dst;
#line 488 "Util.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lingua__KO__Hangul__Util_decomposeHangul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__KO__Hangul__Util_decomposeHangul)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "code");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	UV	code = (UV)SvUV(ST(0))
;
#line 313 "Util.xs"
    UV sindex, lindex, vindex, tindex;
    SV *decomp;
    U8 *t, temp[3 * UTF8_MAXLEN + 1];
    STRLEN tlen;
    int notwantarray;
#line 513 "Util.c"
#line 319 "Util.xs"
    notwantarray = (GIMME_V != G_ARRAY);
    if (! Hangul_IsS(code)) {
	if (notwantarray)
	    XSRETURN_UNDEF;
	else
	    XSRETURN_EMPTY;
    }

    sindex = code - Hangul_SBase;
    lindex =  sindex / Hangul_NCount;
    vindex = (sindex % Hangul_NCount) / Hangul_TCount;
    tindex =  sindex % Hangul_TCount;

    if (notwantarray) {
	t = temp;
	t = uvuni_to_utf8(t, (lindex + Hangul_LBase));
	t = uvuni_to_utf8(t, (vindex + Hangul_VBase));
	if (tindex)
	    t = uvuni_to_utf8(t, (tindex + Hangul_TBase));
	*t = '\0';
	tlen = strlen((char*)temp);
	decomp = sv_2mortal(newSVpvn((char*)temp, tlen));
	SvUTF8_on(decomp);
	XPUSHs(decomp);
    }
    else {
	XPUSHs(sv_2mortal(newSVuv(lindex + Hangul_LBase)));
	XPUSHs(sv_2mortal(newSVuv(vindex + Hangul_VBase)));
	if (tindex)
	    XPUSHs(sv_2mortal(newSVuv(tindex + Hangul_TBase)));
    } /* decomposeHangul */
#line 546 "Util.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lingua__KO__Hangul__Util_getHangulComposite); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__KO__Hangul__Util_getHangulComposite)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "uv, uv2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	UV	uv = (UV)SvUV(ST(0))
;
	UV	uv2 = (UV)SvUV(ST(1))
;
#line 358 "Util.xs"
    UV ret_uv;
#line 568 "Util.c"
#line 360 "Util.xs"
    ret_uv = compositeHangul(uv, uv2);
    if (ret_uv)
	XPUSHs(sv_2mortal(newSVuv(ret_uv)));
    else
	XSRETURN_UNDEF;
#line 575 "Util.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lingua__KO__Hangul__Util_getHangulName); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__KO__Hangul__Util_getHangulName)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "code");
    {
	UV	code = (UV)SvUV(ST(0))
;
#line 372 "Util.xs"
    UV sindex, lindex, vindex, tindex;
    char name[Hangul_NameMax + 1];
    STRLEN nlen;
#line 595 "Util.c"
	SV *	RETVAL;
#line 376 "Util.xs"
    if (! Hangul_IsS(code))
	XSRETURN_UNDEF;

    sindex = code - Hangul_SBase;
    lindex =  sindex / Hangul_NCount;
    vindex = (sindex % Hangul_NCount) / Hangul_TCount;
    tindex =  sindex % Hangul_TCount;
    strcpy(name, Hangul_BName);
    strcat(name, hangul_JamoL[lindex]);
    strcat(name, hangul_JamoV[vindex]);
    strcat(name, hangul_JamoT[tindex]);
    nlen = strlen(name);
    RETVAL = newSVpvn(name, nlen);
#line 611 "Util.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lingua__KO__Hangul__Util_parseHangulName); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__KO__Hangul__Util_parseHangulName)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
#line 398 "Util.xs"
    UV uv;
    char jamoL[Hangul_LLenMax];
    char jamoV[Hangul_VLenMax];
    char jamoT[Hangul_TLenMax];
    char *s, *p, *e;
    STRLEN slen, llen, vlen, tlen;
#line 635 "Util.c"
	SV *	RETVAL;
#line 405 "Util.xs"
    s = SvPV(sv, slen);
    e = s + slen;

    if (slen <= Hangul_BNameLen ||
	Hangul_NameMax < slen ||
	strnNE(s, Hangul_BName, Hangul_BNameLen))
	XSRETURN_UNDEF;

    s += Hangul_BNameLen;
    for (p = s; p < e && p < s + Hangul_LLenMax; p++) {
	if (IsHangulNameC(*p))
	    jamoL[p - s] = *p;
	else if (IsHangulNameV(*p))
	    break;
	else
	    XSRETURN_UNDEF;
    }
    llen = p - s;
    s += llen;

    for (p = s; p < e && p < s + Hangul_VLenMax; p++) {
	if (IsHangulNameV(*p))
	    jamoV[p - s] = *p;
	else if (IsHangulNameC(*p))
	    break;
	else
	    XSRETURN_UNDEF;
    }
    vlen = p - s;
    if (! vlen) /* Vowel must have length */
	XSRETURN_UNDEF;

    s += vlen;
    for (p = s; p < e && p < s + Hangul_TLenMax; p++) {
	if (IsHangulNameC(*p))
	    jamoT[p - s] = *p;
	else
	    XSRETURN_UNDEF;
    }
    tlen = p - s;
    s += tlen;
    if (s != e) /* has weird trailing char(s) */
	XSRETURN_UNDEF;

    uv = Hangul_SBase;

    if (llen == 0) {
	uv +=  11 * Hangul_NCount;
    }
    else if (llen == 1) {
	switch (jamoL[0]) {
	case 'G':
	    uv +=  0 * Hangul_NCount;
	    break;
	case 'N':
	    uv +=  2 * Hangul_NCount;
	    break;
	case 'D':
	    uv +=  3 * Hangul_NCount;
	    break;
	case 'R':
	    uv +=  5 * Hangul_NCount;
	    break;
	case 'M':
	    uv +=  6 * Hangul_NCount;
	    break;
	case 'B':
	    uv +=  7 * Hangul_NCount;
	    break;
	case 'S':
	    uv +=  9 * Hangul_NCount;
	    break;
	case 'J':
	    uv += 12 * Hangul_NCount;
	    break;
	case 'C':
	    uv += 14 * Hangul_NCount;
	    break;
	case 'K':
	    uv += 15 * Hangul_NCount;
	    break;
	case 'T':
	    uv += 16 * Hangul_NCount;
	    break;
	case 'P':
	    uv += 17 * Hangul_NCount;
	    break;
	case 'H':
	    uv += 18 * Hangul_NCount;
	    break;
	default:
	    XSRETURN_UNDEF;
	}
    }
    else { /* llen == 2 */
	if (jamoL[0] != jamoL[1])
	    XSRETURN_UNDEF;
	switch (jamoL[0]) {
	case 'G':
	    uv +=  1 * Hangul_NCount;
	    break;
	case 'D':
	    uv +=  4 * Hangul_NCount;
	    break;
	case 'B':
	    uv +=  8 * Hangul_NCount;
	    break;
	case 'S':
	    uv += 10 * Hangul_NCount;
	    break;
	case 'J':
	    uv += 13 * Hangul_NCount;
	    break;
	default:
	    XSRETURN_UNDEF;
	}
    } /* jamoL */

    if (vlen == 1) {
	switch (jamoV[0]) {
	case 'A':
	    uv +=  0 * Hangul_TCount;
	    break;
	case 'E':
	    uv +=  5 * Hangul_TCount;
	    break;
	case 'O':
	    uv +=  8 * Hangul_TCount;
	    break;
	case 'U':
	    uv += 13 * Hangul_TCount;
	    break;
	case 'I':
	    uv += 20 * Hangul_TCount;
	    break;
	default:
	    XSRETURN_UNDEF;
	}
    }
    else if (vlen == 2) {
	if (jamoV[0] == 'A') {
	    if (jamoV[1] == 'E')
		uv +=  1 * Hangul_TCount;
	    else
		XSRETURN_UNDEF;
	}
	else if (jamoV[0] == 'O') {
	    if (jamoV[1] == 'E')
		uv += 11 * Hangul_TCount;
	    else
		XSRETURN_UNDEF;
	}
	else if (jamoV[0] == 'E') {
	    if (jamoV[1] == 'O')
		uv +=  4 * Hangul_TCount;
	    else if (jamoV[1] == 'U')
		uv += 18 * Hangul_TCount;
	    else
		XSRETURN_UNDEF;
	}
	else if (jamoV[0] == 'Y') {
	    switch (jamoV[1]) {
	    case 'A':
		uv +=  2 * Hangul_TCount;
		break;
	    case 'E':
		uv +=  7 * Hangul_TCount;
		break;
	    case 'O':
		uv += 12 * Hangul_TCount;
		break;
	    case 'U':
		uv += 17 * Hangul_TCount;
		break;
	    case 'I':
		uv += 19 * Hangul_TCount;
		break;
	    default :
		XSRETURN_UNDEF;
	    }
	}
	else if (jamoV[0] == 'W') {
	    switch (jamoV[1]) {
	    case 'A':
		uv +=  9 * Hangul_TCount;
		break;
	    case 'E':
		uv += 15 * Hangul_TCount;
		break;
	    case 'I':
		uv += 16 * Hangul_TCount;
		break;
	    default :
		XSRETURN_UNDEF;
	    }
	}
	else
	    XSRETURN_UNDEF;
    }
    else { /* vlen == 3 */
	if (jamoV[0] == 'Y') {
	    if (jamoV[1] == 'A' && jamoV[2] == 'E')
		uv +=  3 * Hangul_TCount;
	    else if (jamoV[1] == 'E' && jamoV[2] == 'O')
		uv +=  6 * Hangul_TCount;
	    else
		XSRETURN_UNDEF;
	}
	else if (jamoV[0] == 'W') {
	    if (jamoV[1] == 'A' && jamoV[2] == 'E')
		uv +=  10 * Hangul_TCount;
	    else if (jamoV[1] == 'E' && jamoV[2] == 'O')
		uv +=  14 * Hangul_TCount;
	    else
		XSRETURN_UNDEF;
	}
	else
	    XSRETURN_UNDEF;
    } /* jamoV */

    if (tlen == 0) {
	uv +=  0;
    }
    else if (tlen == 1) {
	switch (jamoT[0]) {
	case 'G':
	    uv +=  1;
	    break;
	case 'N':
	    uv +=  4;
	    break;
	case 'D':
	    uv +=  7;
	    break;
	case 'L':
	    uv +=  8;
	    break;
	case 'M':
	    uv += 16;
	    break;
	case 'B':
	    uv += 17;
	    break;
	case 'S':
	    uv += 19;
	    break;
	case 'J':
	    uv += 22;
	    break;
	case 'C':
	    uv += 23;
	    break;
	case 'K':
	    uv += 24;
	    break;
	case 'T':
	    uv += 25;
	    break;
	case 'P':
	    uv += 26;
	    break;
	case 'H':
	    uv += 27;
	    break;
	default:
	    XSRETURN_UNDEF;
	}
    }
    else { /* tlen == 2 */
	if (jamoT[0] == 'G') {
	    if (jamoT[1] == 'G')
		uv +=  2;
	    else if (jamoT[1] == 'S')
		uv +=  3;
	    else
		XSRETURN_UNDEF;
	}
	else if (jamoT[0] == 'N') {
	    switch (jamoT[1]) {
	    case 'J':
		uv +=  5;
		break;
	    case 'H':
		uv +=  6;
		break;
	    case 'G':
		uv += 21;
		break;
	    default :
		XSRETURN_UNDEF;
	    }
	}
	else if (jamoT[0] == 'L') {
	    switch (jamoT[1]) {
	    case 'G':
		uv +=  9;
		break;
	    case 'M':
		uv += 10;
		break;
	    case 'B':
		uv += 11;
		break;
	    case 'S':
		uv += 12;
		break;
	    case 'T':
		uv += 13;
		break;
	    case 'P':
		uv += 14;
		break;
	    case 'H':
		uv += 15;
		break;
	    default:
		XSRETURN_UNDEF;
	    }
	}
	else if (jamoT[0] == 'B' && jamoT[1] == 'S')
	    uv += 18;
	else if (jamoT[0] == 'S' && jamoT[1] == 'S')
	    uv += 20;
	else
	    XSRETURN_UNDEF;
    } /* jamoT */

    RETVAL = newSVuv(uv);
#line 966 "Util.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lingua__KO__Hangul__Util_getSyllableType); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__KO__Hangul__Util_getSyllableType)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "code");
    {
	UV	code = (UV)SvUV(ST(0))
;
#line 742 "Util.xs"
    char * hangtype;
    STRLEN typelen;
#line 986 "Util.c"
	SV *	RETVAL;
#line 745 "Util.xs"
    if (Jamo_LIni <= code && code <= Jamo_LFin || code == Jamo_LFill) {
	hangtype = "L"; typelen = 1;
    }
    else if (Jamo_VIni <= code && code <= Jamo_VFin) {
	hangtype = "V"; typelen = 1;
    }
    else if (Jamo_TIni <= code && code <= Jamo_TFin) {
	hangtype = "T"; typelen = 1;
    }
    else if (Hangul_SBase <= code && code <= Hangul_SFinal) {
	if ((code - Hangul_SBase) % Hangul_TCount) {
	    hangtype = "LVT"; typelen = 3;
	}
	else {
	    hangtype = "LV"; typelen = 2;
	}
    }
    else {
	hangtype = "NA"; typelen = 2;
    }
    RETVAL = newSVpvn(hangtype, typelen);
#line 1010 "Util.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lingua__KO__Hangul__Util_isStandardForm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lingua__KO__Hangul__Util_isStandardForm)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "src");
    {
	SV *	src = ST(0)
;
#line 778 "Util.xs"
    UV uv;
    SV *dst;
    STRLEN srclen, retlen;
    U8 *s, *e, *p;
    char pretype, curtype, nexttype;
#line 1034 "Util.c"
	SV *	RETVAL;
#line 784 "Util.xs"
    s = (U8*)sv_2pvunicode(src,&srclen);
    e = s + srclen;

    if (ix) {
	dst = newSV(1);
	SvPOK_only(dst);
	SvUTF8_on(dst);
    }
    else {
	dst = &PL_sv_yes;
    }
    pretype = 'N';

    for (p = s; p < e; p += retlen) {
	uv = utf8n_to_uvuni(p, e - p, &retlen, 0);
	if (!retlen)
	    croak(ErrRetlenIsZero);

	if (Jamo_LIni <= uv && uv <= Jamo_LFin || uv == Jamo_LFill) {
	    curtype = nexttype = 'L';
	}
	else if (Jamo_VIni <= uv && uv <= Jamo_VFin) {
	    curtype = nexttype = 'V';
	}
	else if (Jamo_TIni <= uv && uv <= Jamo_TFin) {
	    curtype = nexttype = 'T';
	}
	else if (Hangul_SBase <= uv && uv <= Hangul_SFinal) {
	    if ((uv - Hangul_SBase) % Hangul_TCount) {
		curtype = 'L'; nexttype = 'T';
	    }
	    else {
		curtype = 'L'; nexttype = 'V';
	    }
	}
	else {
	    curtype = nexttype = 'N';
	}

	if (pretype == curtype) {
	    1;
	}
	else if (curtype == 'V') {
	    if (pretype != 'L') {
		if (ix)
		    sv_catpvn(dst, LKHU_LF_STRING, LKHU_LF_LENGTH);
		else {
		    dst = &PL_sv_no;
		    break;
		}
	    }
	}
	else {
	    if (pretype == 'L') {
		if (ix)
		    sv_catpvn(dst, LKHU_VF_STRING, LKHU_VF_LENGTH);
		else {
		    dst = &PL_sv_no;
		    break;
		}
	    }
	    if (pretype != 'V' && curtype == 'T') {
		if (ix) {
		    sv_catpvn(dst, LKHU_LF_STRING, LKHU_LF_LENGTH);
		    sv_catpvn(dst, LKHU_VF_STRING, LKHU_VF_LENGTH);
		}
		else {
		    dst = &PL_sv_no;
		    break;
		}
	    }
	}

	pretype = nexttype;
	if (ix) {
	    sv_catpvn(dst, (char *)p, retlen);
	}
    }
    if (pretype == 'L') {
	if (ix)
	    sv_catpvn(dst, LKHU_VF_STRING, LKHU_VF_LENGTH);
	else {
	    dst = &PL_sv_no;
	}
    }
    RETVAL = dst;
#line 1123 "Util.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Lingua__KO__Hangul__Util); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Lingua__KO__Hangul__Util)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

    {
        CV * cv;

        (void)newXSproto_portable("Lingua::KO::Hangul::Util::composeJamo", XS_Lingua__KO__Hangul__Util_composeJamo, file, "$");
        (void)newXSproto_portable("Lingua::KO::Hangul::Util::composeSyllable", XS_Lingua__KO__Hangul__Util_composeSyllable, file, "$");
        cv = newXSproto_portable("Lingua::KO::Hangul::Util::decomposeJamo", XS_Lingua__KO__Hangul__Util_decomposeSyllable, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Lingua::KO::Hangul::Util::decomposeSyllable", XS_Lingua__KO__Hangul__Util_decomposeSyllable, file, "$");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Lingua::KO::Hangul::Util::decomposeHangul", XS_Lingua__KO__Hangul__Util_decomposeHangul, file, "$");
        (void)newXSproto_portable("Lingua::KO::Hangul::Util::getHangulComposite", XS_Lingua__KO__Hangul__Util_getHangulComposite, file, "$$");
        (void)newXSproto_portable("Lingua::KO::Hangul::Util::getHangulName", XS_Lingua__KO__Hangul__Util_getHangulName, file, "$");
        (void)newXSproto_portable("Lingua::KO::Hangul::Util::parseHangulName", XS_Lingua__KO__Hangul__Util_parseHangulName, file, "$");
        (void)newXSproto_portable("Lingua::KO::Hangul::Util::getSyllableType", XS_Lingua__KO__Hangul__Util_getSyllableType, file, "$");
        cv = newXSproto_portable("Lingua::KO::Hangul::Util::insertFiller", XS_Lingua__KO__Hangul__Util_isStandardForm, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Lingua::KO::Hangul::Util::isStandardForm", XS_Lingua__KO__Hangul__Util_isStandardForm, file, "$");
        XSANY.any_i32 = 0;
    }
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

